/*
 * source/edit/edit.c
 * SpacePigs VectorMania Edit part
 *
 * 1991-07-19 : Coding begun
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*********************** Kvar att gra *********************************
 *
 * Erase:
 *   total omskrivning.
 *
 * Blandat:
 *   utritning av grid
 *   Statusruta med all "viktig" info.. (position,frg,bollradie,skala,tool mm)
 *   Are you sure.. lite hr och dr (avstngbart)
 *   Cursortangenterna (flytta markren skalsteg i editfnstret)
 *   Horisontal,vertikal och Z lock (bst i meny)
 *   LINE-mode i 3D-vyn
 *
 * Kanske...
 *   flerfrgs-3d-skrm om man vill (enbart 3D vyn)
 *   Bollar precis intill varann vid utsttning och flyttning
 *   gra om fnster till normala, och anvnda layers.library fr klippningen
 *
 * Menyer:
 *   ganska mycket...
 *   
 **********************************************************************/

#define EDIT_GLOBAL

#include "other/debug.h"
#include "vector/vector.h"
#include "graphics/graphics.h"
#include "edit/edit.h"
#include "edit/edit_globals.h"

extern struct windowdata drawwindow;

void initedit(void)
{
    createeditmenu();
    openwindow(&editxwindow);
    seteditmenu(&editxwindow);
    cursoron();
    openwindow(&editywindow);
    seteditmenu(&editywindow);
    cursoron();
    openwindow(&editzwindow);
    seteditmenu(&editzwindow);
    cursoron();
    seteditmenu(&drawwindow);

    numeditcords = 0;
    numselect = 0;
    nextdraw = 0;
    editdraw[nextdraw] = DT_END;
    scale = ZOOMDEFAULT;
    cursor.x = 0;
    cursor.y = 0;
    cursor.z = 0;
    center.x = 0;
    center.y = 0;
    center.z = 0;
    editballradie = 10;
    realnumcords = 0;
    colorpoint = COLORPOINT;
    colorselpoint = COLORSELPOINT;
    colorsurf = COLORSURF;
    colorline = COLORLINE;
    colorball = COLORBALL;
    colorcursor = COLORCURSOR;
    currenttool = TOOL_NONE;
    setgrid(1);
    draweditcursor();

    strncpy(objfilename, OBJUNNAMED, OBJFILENAMEMAX);
}

void closeeditwindow(struct windowdata *windat)
{
	switch(windat->type) {
	case WINDOW_X:
		seteditmenustate(MENU_PREFS,MENU_PREFS_X,~0,0);
		break;
	case WINDOW_Y:
		seteditmenustate(MENU_PREFS,MENU_PREFS_Y,~0,0);
		break;
	case WINDOW_Z:
		seteditmenustate(MENU_PREFS,MENU_PREFS_Z,~0,0);
		break;
	}
	closewindow(windat);
}
			
void erase(void)
{
    int elem, numerase;
    for (elem = 0, numerase = 0; (elem = findelem(editcordselect, numselect, elem)) >= 0; numerase++) {
	saydebug("erase: found element %d\n", elem);
	eraseelem(elem);
    }
    if (numerase == 0) {
	if (elem == -1)
	    saydebug("Found partial element(s)\n", 0);
	if (elem == -2)
	    saydebug("Found nothing\n", 0);	/* erase all selected points */
    }
}

/* TOOL FUNKTIONER:
** NAMN:	FUNKTION:
** TOOL_NONE	Ingen alls...
** TOOL_VERTEX	Skapa punkter
** TOOL_SURFACE	Skapa en yta
** TOOL_LINE	Skapa en linje
** TOOL_BALL	Skapa bollar
** TOOL_GRAB	Flytta p punkter
**
** TOOL jobbar med hjlp av hgra musknappen.
** Startas med settooltype.
** Konfirmeras med att vlja tooltype igen (vilken som helst, ven samma)
** Avbryts med escape (ingen frndring)
** Funktioner som anvnds:
** settooltype		vlja tooltype
** tool_move		markren har flyttat p sig
** drawedittooldraw	rita ut grafiken
** tool_action		gra ngot (hgra musknappen trycks ned)
** tool_cancel		avbryta ett tool (med esc-knappen)
*/

/* settooltype(tooltype,wintype)
** Aktiverar ett verktyg som jobbar med hgra musknappen.
*/
void settooltype(TOOLTYPE tool, WINDOWTYPE win)
{
    int active = 0;
    TOOLTYPE lasttool = currenttool;

    currenttool = TOOL_NONE;
    if (lasttool == tool) {
	active = 1;
    }
    settoolgadg(lasttool, 0);
    tool_end(lasttool);
    if (tool_start(tool, active, win)) {
	currenttool = tool;
    } else {
	currenttool = TOOL_NONE;
    }
    settoolgadg(currenttool, 1);
    settoolmenu(currenttool);

    drawedittooldraw();
}

/* resettools()
** terstller tool_systemet till standardlget.
*/
void resettools(void)
{
    settoolgadg(currenttool,0);
    currenttool=TOOL_NONE;
    settoolgadg(currenttool, 1);
    settoolmenu(currenttool);
}

/* tool_move:
** Anropas nr markren har flyttat p sig.
*/
void tool_move(CORD3D * pos)
{
    CORD3D cord;
    cord = *pos;

    switch (currenttool) {
    case TOOL_NONE:
    	break;
    case TOOL_VERTEX:
	break;
    case TOOL_SURFACE:
	break;
    case TOOL_LINE:
	break;
    case TOOL_BALL:
	break;
    case TOOL_GRAB:
	editmovegrab(&cord);
	updateeditdisplay();
	break;
    case TOOL_SQUARE:
/*    	switch(   beroende av vilket fnster... */
    case TOOL_CUBE:
	if (numselect == 2 && realnumcords < numeditcords) {
	    /* Hr borde det vara lite mera avancerad kontroll av om det
	  r en ny eller gammal kordinat som r vald sist... inte senaste
	  skapade. */
	    setvertex(&cord, numeditcords - 1);
	    updateeditdisplay();
	}
	break;
    default:
	saydebug("Tool move: unknown tooltype:%d\n", currenttool);
	break;
    }
}

void drawedittooldraw()
{
    editdrawtooldraw(editcordselect, numselect, currenttool);
}

void tool_action(CORD3D * cord, int doubleclick, struct windowdata * windat)
{
    int num;
    if (doubleclick) {
	num = findnearcursor(windat->type);
    	if (num < 0) {
	    doubleclick = 0;
	}
    }
    switch (currenttool) {
    case TOOL_NONE:
	break;
    case TOOL_LINE:
	if (!doubleclick)
	    num = createvertex(cord);
	selectcord(num);
	if (numselect >= 2)
	    editdrawtooldraw(&editcordselect[numselect - 2], 2, TOOL_LINE);
	break;
    case TOOL_SURFACE:
	if (!doubleclick)
	    num = createvertex(cord);
	selectcord(num);
	if (numselect >= 2)
	    editdrawtooldraw(&editcordselect[numselect - 2], 2, TOOL_SURFACE);
	break;
    case TOOL_BALL:
	if (!doubleclick)
	    num = createvertex(cord);
	selectcord(num);
	editdrawtooldraw(&editcordselect[numselect - 1], 1, TOOL_BALL);
	break;
    case TOOL_VERTEX:
	if (!doubleclick)
	    num = createvertex(cord);
	selectcord(num);
	break;
    case TOOL_GRAB:
	return;
    case TOOL_CUBE:
	switch (numselect) {
	case 0:
	case 1:
	    if (!doubleclick)
	    	num = createvertex(cord);
	    selectcord(num);
	    drawedittooldraw();
	    break;
	case 2:
	    tool_end(currenttool);
	    break;
	default:
	    saydebug("tool_action: TOOL_CUBE, invalid num selected cords:%d\n", numselect);
	    deselectall();
	    numeditcords = realnumcords;
	    updateeditdisplay();
	    break;
	}
    default:
	saydebug("Unhandled tool:%d\n", currenttool);
    }
}

void tool_cancel(void)
{
    int i;

    switch (currenttool) {
    case TOOL_NONE:
	deselectall();
	updateeditdisplay();
	break;
    case TOOL_VERTEX:
    case TOOL_LINE:
    case TOOL_SURFACE:
    case TOOL_BALL:
	for (i = realnumselected; i < numselect; i++) {
	    deselectcord(editcordselect[i]);
	}
	numselect = realnumselected;
	numeditcords = realnumcords;
	updateeditdisplay();
	break;
    case TOOL_GRAB:
	grab_cancel();
	for (i = realnumselected; i < numselect; i++) {
	    deselectcord(editcordselect[i]);
	}
	numselect = realnumselected;
	updateeditdisplay();
	break;
    default:
	saydebug("Tool_cancel: unknown currenttool:%d\n", currenttool);
	break;
    }
    settooltype(currenttool, 0);
}

int tool_start(TOOLTYPE tool, int currentactive, WINDOWTYPE win)
{
    int num;
    CORD3D cord;
    getcursor(&cord);

    realnumselected = numselect;

    switch (tool) {
    case TOOL_VERTEX:
    case TOOL_SURFACE:
    case TOOL_LINE:
    case TOOL_BALL:
	break;
    case TOOL_GRAB:
	if (currentactive) {
	    setgrab(0, 0);
	} else {
	    if(setgrab(1, win)) return 1;
	}
	return 0;
    case TOOL_SQUARE:
    case TOOL_CUBE:
	if (numselect == 0) {
	    num = createvertex(&cord);
	    selectcord(num);
	}
	if (numselect == 1) {
	    num = createvertex(&cord);
	    selectcord(num);
	}
	if (numselect > 2) {
	    deselectall();
	    numeditcords = realnumcords;
	}
	break;
    default:
	saydebug("TOOL_START: Unknown tool %d\n", tool);
	return 0;
    }
    return 1;
}

void tool_end(enum tooltype tool)
{
    switch (tool) {
    case TOOL_VERTEX:
	if (numselect > 0) {
		realnumcords = numeditcords;
		deselectall();
		updateeditdisplay();
	}
	break;
    case TOOL_SURFACE:
	if (numselect >= 2) {
	    realnumcords = numeditcords;
	    createsurf(editcordselect, numselect);
	    deselectall();
	    updateeditdisplay();
	}
	break;
    case TOOL_LINE:
	if (numselect >= 2) {
	    realnumcords = numeditcords;
	    createlinelist(editcordselect, numselect);
	    deselectall();
	    updateeditdisplay();
	}
	break;
    case TOOL_BALL:
	if (numselect>0) {
		realnumcords = numeditcords;
		createballlist(editcordselect, numselect);
		deselectall();
		updateeditdisplay();
	}
	break;
    case TOOL_GRAB:
	setgrab(0, 0);
	deselectall();
	updateeditdisplay();
	break;
    }
}

void settoolgadg(TOOLTYPE type, int state)
{
    GADGETID gadg;

    switch (type) {
    case TOOL_NONE:
	return;
    case TOOL_VERTEX:
	gadg = GADGET_VERTEX;
	break;
    case TOOL_LINE:
	gadg = GADGET_LINE;
	break;
    case TOOL_SURFACE:
	gadg = GADGET_SURFACE;
	break;
    case TOOL_BALL:
	gadg = GADGET_BALL;
	break;
    case TOOL_GRAB:
	gadg = GADGET_GRAB;
	break;
    default:
	saydebug("Unknown tool-gadget type:%d\n", type);
	return;
    }
    setgadget(&editxwindow, gadg, state);
    setgadget(&editywindow, gadg, state);
    setgadget(&editzwindow, gadg, state);
}

void editdrawtooldraw(char *cords, int numcords, TOOLTYPE tool)
{
    if (selectwindow(&editxwindow)) {
	cursoroff();
	drawtooldraw(cords, numcords, X_AXEL, tool);
	cursoron();
    }
    if (selectwindow(&editywindow)) {
	cursoroff();
	drawtooldraw(cords, numcords, Y_AXEL, tool);
	cursoron();
    }
    if (selectwindow(&editzwindow)) {
	cursoroff();
	drawtooldraw(cords, numcords, Z_AXEL, tool);
	cursoron();
    }
}

void drawtooldraw(char *cords, int numcords, AXEL axel, TOOLTYPE tool)
{
    CORD3D cord;
    int i;

    switch (tool) {
    case TOOL_NONE:
	return;
    case TOOL_VERTEX:
	return;
    case TOOL_BALL:
	setcolor(colorball);
	{
	    int radie = IMULIF(editballradie, scale);
	    for (i = 0; i < numcords; i++) {
		geteditcord(&editdispcord[cords[i]], &cord, axel);
		circle(&cord, radie);
	    }
	}
	break;
    case TOOL_LINE:
	setcolor(colorline);
	if (numcords < 2)
	    return;
	geteditcord(&editdispcord[cords[0]], &cord, axel);
	move(&cord);
	for (i = 1; i < numcords; i++) {
	    geteditcord(&editdispcord[cords[i]], &cord, axel);
	    draw(&cord);
	}
	break;
    case TOOL_SURFACE:
	setcolor(colorsurf);
	if (numcords < 2)
	    return;
	geteditcord(&editdispcord[cords[0]], &cord, axel);
	move(&cord);
	for (i = 1; i < numcords; i++) {
	    geteditcord(&editdispcord[cords[i]], &cord, axel);
	    draw(&cord);
	}
	break;
    case TOOL_SQUARE:
    case TOOL_CUBE:
	setcolor(colorsurf);
	if (numcords == 2) {
	    CORD3D cord[4];
	    geteditcord(&editdispcord[cords[0]], &cord[0], axel);
	    geteditcord(&editdispcord[cords[1]], &cord[1], axel);
	    cord[2].x = cord[0].x;
	    cord[2].y = cord[1].y;
	    cord[3].x = cord[1].x;
	    cord[3].y = cord[0].y;
	    move(&cord[0]);
	    draw(&cord[2]);
	    draw(&cord[1]);
	    draw(&cord[3]);
	    draw(&cord[0]);
	}
	break;
    default:
	saydebug("Draw tooldraw, unknown tooltype %d\n", tool);
	break;
    }
}

void settoolmenu(TOOLTYPE tool)
{
    enum MENU_TOOL menu;

    switch (tool) {
    case TOOL_NONE:
	menu = MENU_TOOL_NONE;
	break;
    case TOOL_VERTEX:
	menu = MENU_TOOL_VERTEX;
	break;
    case TOOL_SURFACE:
	menu = MENU_TOOL_SURFACE;
	break;
    case TOOL_LINE:
	menu = MENU_TOOL_LINE;
	break;
    case TOOL_BALL:
	menu = MENU_TOOL_BALLS;
	break;
    case TOOL_GRAB:
	menu = MENU_TOOL_GRAB;
	break;
    case TOOL_SQUARE:
	menu = MENU_TOOL_SQUARE;
	break;
    case TOOL_CUBE:
	menu = MENU_TOOL_CUBE;
	break;
    default:
	saydebug("settoolmenu: unknown tool %d\n", tool);
	return;
    }
    seteditmenustate(MENU_TOOL, menu, ~0, 1);
}

void setvertex(CORD3D * cord, int num)
{
    VECTINT x, y, z;

    x = cord->x;
    y = cord->y;
    z = cord->z;

    editcord[num].x = x;
    editcord[num].y = y;
    editcord[num].z = z;
}

void getcursor(CORD3D * cord)
{
    cord->x = cursor.x;
    cord->y = cursor.y;
    cord->z = cursor.z;
}

void setgrid(int size)
{
    grid = size;
    seteditmenustate(MENU_GRID, size - 1, ~0, 1);
}

void snapgrid(CORD3D * cord)
{
    VECTINT x, y, z;
    int g2 = grid / 2;

    x = cord->x;
    y = cord->y;
    z = cord->z;

    if (x < 0)
	x = x - g2;
    else
	x = x + g2;
    x = x - x % grid;

    if (y < 0)
	y = y - g2;
    else
	y = y + g2;
    y = y - y % grid;

    if (z < 0)
	z = z - g2;
    else
	z = z + g2;
    z = z - z % grid;

    cord->x = x;
    cord->y = y;
    cord->z = z;
}
