/*
 * SpacePigs VectorMania Edit part globals and defines
 */

typedef enum tooltype {
    TOOL_NONE = 0,
    TOOL_VERTEX,
    TOOL_LINE,
    TOOL_SURFACE,
    TOOL_BALL,
    TOOL_GRAB,
    TOOL_CUBE,
    TOOL_SQUARE
} TOOLTYPE;

/* MENU ID */
enum MENUS {
    MENU_PROJECT = 0,
    MENU_TOOL,
    MENU_GRID,
    MENU_BALL,
    MENU_EDIT,
    MENU_PREFS
};

enum MENU_PROJECT {
    MENU_PROJECT_NEW = 0,
    MENU_PROJECT_LOAD,
    MENU_PROJECT_SAVE,
    MENU_PROJECT_SAVEAS,
    MENU_PROJECT_QUIT
};

enum MENU_TOOL {
    MENU_TOOL_ACTION = 0,
    MENU_TOOL_BAR1,
    MENU_TOOL_NONE,
    MENU_TOOL_VERTEX,
    MENU_TOOL_SURFACE,
    MENU_TOOL_LINE,
    MENU_TOOL_BALLS,
    MENU_TOOL_GRAB,
    MENU_TOOL_SQUARE,
    MENU_TOOL_CUBE,
    MENU_TOOL_BAR2,
    MENU_TOOL_CANCEL
};

enum MENU_EDIT {
    MENU_EDIT_SELECT = 0,
    MENU_EDIT_ERASE,
    MENU_EDIT_GRAB,
    MENU_EDIT_COPY,
    MENU_EDIT_SNAP,
    MENU_EDIT_CENTER
};

enum MENU_SELECT {
    MENU_SELECT_VERTEX = 0,
    MENU_SELECT_ELEM,
    MENU_SELECT_SELELEM,
    MENU_SELECT_CONNECTED,
    MENU_SELECT_ALLCONN,
    MENU_SELECT_ALLELEM,
    MENU_SELECT_ALL
};

enum MENU_PREFS {
    MENU_PREFS_OK=0,
    MENU_PREFS_X,
    MENU_PREFS_Y,
    MENU_PREFS_Z,
    MENU_PREFS_FILL,
    MENU_PREFS_LINES,
    MENU_PREFS_WB,
    MENU_PREFS_PENS,
    MENU_PREFS_PALLETTE
};
	
#define EDITCORD_SIZE	(127)
#define EDITDRAW_SIZE	(EDITCORD_SIZE*5)
#define DCLICKLIMIT	(5)
#define FINDLIMIT	(10)
#define FINDZFACTOR	(20)
#define MOVECENTERSTEP	(50)
/* ZOMFACTOR = 1.5 */
#define ZOOMFACTOR	(0x180)
/* ZOOMMAX = 50 */
#define ZOOMMAX		(ITOF(50))
/* ZOOMMIN = .3 */
#define ZOOMMIN		(0x030)
#define ZOOMDEFAULT	(ITOF(1))
#define COLORPOINT	(WHITE)
#define COLORSURF	(GRAY3)
#define COLORCURSOR	(WHITE)
#define COLORLINE	(GRAY1)
#define COLORSELPOINT	(RED)
#define COLORBALL	(GRAY2)

/* Cord flags */
#define CORD_SELECTED	BITDEF(0)
#define CORD_GRAB	BITDEF(1)
#define CORD_NOSNAP	BITDEF(2)
#define CORD_GRABFLAGS	(CORD_GRAB|CORD_NOSNAP)

/* Load and save macros */
#define CURRENTFILENAME	((char *)0L)
#define REQUESTFILENAME ((char *)-1L)
#define OBJFILENAMEMAX	(200)
#define OBJUNNAMED	("Unnamed.VMO")

/* external functions */
extern void seteditmenu(struct windowdata * windat);
extern void createeditmenu(void);
extern void freeeditmenu(void);
void seteditmenustate(int menu, int item, int subitem, int state);
int geteditmenustate(int menu, int item, int subitem);

/* local funktions */
void updateeditdisplay(void);
void draweditobject(void);
void draweditdraw(void);
void draweditpoints(void);
void draweditpoint(int cord);
void draweditselpoint(int cord);
void draweditselpoints(void);
void draweditcursor(void);
void displayscalecords(struct Cord3d * source, struct Cord3d * dest, int numcords);
void editdrawpoint(struct Cord3d * cord, char flags);
void editdrawpoints(struct Cord3d cords[], char flags[], int numcords);
void editdrawselpoint(struct Cord3d * cord);
void editdrawselpointlist(struct Cord3d * cords, char *pointlist, char listlen);
void editdrawdraw(struct Cord3d * cords, char *drawlist);
void editdisplayscalecords(void);
void drawpoint(struct Cord3d * cord, char flags, enum Axel axel);
void drawpoints(struct Cord3d cords[], char flags[], int numcords, enum Axel axel);
void drawselpoint(struct Cord3d * cord, enum Axel axel);
void drawselpointlist(struct Cord3d * cords, char *pointlist, char listlen, enum Axel axel);
void drawcursor(int x, int y);
void geteditcord(struct Cord3d * source, struct Cord3d * dest, enum Axel axel);
void disppoint(struct Cord3d * point);
void dispselpoint(struct Cord3d * point);
int findnear(struct Cord3d * cords, int numcords, struct Cord3d * cord, enum Axel axel, int limit, VECTFLOAT zfactor);
int findnearcursor(enum windowtype type);
void setcursorpos(struct Cord3d * cord);
int snapcursornearest(enum windowtype type);
void movecenter(enum gadgetid id, enum windowtype type);
void zoomin(void);
void zoomout(void);
void setcenter(struct Cord3d * newcent);
void selectnearcursor(enum windowtype type);
void selectcord(int cord);
void deselectcord(int cord);
void deselectall(void);
void erase(void);
int findelem(char *cordlist, int listlen, int start);
int checkifelem(char *elemlist, int numcords, char *cordlist, int listlen);
void eraseelem(int elem);
int setgrab(int state, enum windowtype type);
int setgrabstat(int state, enum windowtype type);
void movegrab(struct Cord3d * start, struct Cord3d * dest);
void editmovegrab(struct Cord3d * pos);
void flipelem(enum windowtype type);
void editflipelem(void);
void reseteditobj3d(void);
void draweditobj3d(void);
void roteditobj(int step, enum Axel axel);
void loadeditobj(char *namn);
void saveeditobj(char *namn);
char *requestfile(char *dirname, char *filename, char *pattern, long flags);
void cleareditobj(void);
void neweditobj(void);
int createvertex(struct Cord3d * cord);
void createsurf(char *cordlist, int listlen);
void createline(int start, int end);
void createlinelist(char *linelist, int listlen);
void createball(int pos, int radie);
void createballlist(char *balllist, int listlen);
void drawdraw(struct Cord3d * cords, char *drawlist, enum Axel axel);
STDDRAWTYPE *drawdrawelem(struct Cord3d * cords, STDDRAWTYPE *elemdraw, enum Axel axel);
void drawdraw_surf(struct Cord3d * cords, STDDRAWTYPE *elemdraw, enum Axel axel);
void drawdraw_line(struct Cord3d * cords, STDDRAWTYPE *elemdraw, enum Axel axel);
void drawdraw_ball(struct Cord3d * cords, STDDRAWTYPE *elemdraw, enum Axel axel);
void settooltype(TOOLTYPE type, WINDOWTYPE win);
void settoolgadg(TOOLTYPE type, int state);
void tool_action(struct Cord3d * cord, int doubleclick, struct windowdata * windat);
void tool_end(TOOLTYPE tool);
void drawedittooldraw(void);
void editdrawtooldraw(char *cords, int numcords, TOOLTYPE tool);
void drawtooldraw(char *cords, int numcords, enum Axel axel, TOOLTYPE tool);
void tool_move(struct Cord3d * pos);
int tool_start(TOOLTYPE tool, int currentactive, WINDOWTYPE win);
void tool_cancel(void);
void grab_cancel(void);
void settoolmenu(TOOLTYPE tool);
void setvertex(struct Cord3d * cord, int vertex);
void getcursor(struct Cord3d * cord);
void setgrid(int size);
void snapgrid(struct Cord3d * cord);
void resettools(void);

#include "edit/edit_data.h"
