/*
 * source/edit/filerequester.c
 * SpacePigs VectorMania FileRequester source Anvnder OS2.0 funktioner fr
 * att f en snygg filvljare.
 */

#include <string.h>

#include <exec/types.h>

#include <utility/tagitem.h>
#include <libraries/asl.h>

#include <proto/asl.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/intuition.h>

#include "other/debug.h"

#define MAXFILENAMEPATH 200
#define MAXFILENAME	200
struct Library *AslBase;

char *
 requestfile(char *dirname, char *filename, char *pattern, long flags)
{
    static char name[MAXFILENAMEPATH];
    char *file;
    struct FileRequester *freq;
    char *retname = 0;
    struct TagItem freqtags[] =
    {
	{ASL_Pattern, 0},
	{ASL_File, 0},
	{ASL_Dir, 0},
	{ASL_FuncFlags, FILF_PATGAD},
	{TAG_DONE, 0}
    };

    if (FilePart(filename) != filename) {
	strncpy(name, filename, MAXFILENAMEPATH);
	file = FilePart(filename);
	dirname = name;
	dirname[file - filename] = '\0';
	filename = file;
    }
    AslBase = OpenLibrary(AslName, 36);
    if (!AslBase) {
	ERROR("Can't open " AslName, 20);
    }
    freq = AllocFileRequest();
    if (!freq) {
	CloseLibrary(AslBase);
	ERROR("Can't alloc FileRequester\n", 20);
    }
    WBenchToFront();
    freqtags[0].ti_Data = (ULONG) pattern;
    freqtags[1].ti_Data = (ULONG) filename;
    freqtags[2].ti_Data = (ULONG) dirname;
    if (AslRequest((APTR) freq, freqtags)) {
	strncpy(name, freq->rf_Dir, MAXFILENAMEPATH);
	AddPart(name, freq->rf_File, MAXFILENAMEPATH);
	retname = name;
    }
    WBenchToBack();
    FreeFileRequest(freq);
    CloseLibrary(AslBase);
    return retname;
}
