/*
 * source/graphics/graphics.h
 * SpacePigs VectorMania Graphics Support prototypes
 *
 * history: 1991-04-26 : New source: Graphics.c
 */
 
#define CURSORWIDTH	(8+3+8)
#define CURSORBWIDTH	(4)
#define CURSORHEIGHT	(4+1+4)
#define CURSORPLANESIZE	(CURSORBWIDTH*CURSORHEIGHT)
#define CURSORCENTX	(8+1)
#define CURSORCENTY	(4)
#define XYRATIO		(133)	/* FLTOF(.52)=133 */

#define AREA_SIZE 100		/* 100/2.5=40 punkter max */

#define DRAWWINDOW	((struct windowdata *)0L)

typedef enum fillmode {
	FILL_MODE_FILL,
	FILL_MODE_LINES
} FILLMODE;

typedef enum windowtype {
    WINDOW_DRAW,
    WINDOW_X,
    WINDOW_Y,
    WINDOW_Z
} WINDOWTYPE;

typedef struct menudata {
    struct Menu *menu;
    struct windowdata *currentwin;
    struct NewMenu *newmenu;
    struct TagItem *newmenutags;
    int flags;
    int pad[10];
} MENUDATA;

typedef struct windowdata {
    WINDOWTYPE type;
    struct NewWindow *newwindow;
    short flags;
    struct Window *window;
    struct RastPort *rastport;
    short minx, maxx;
    short miny, maxy;
    short xcenter;
    short ycenter;
    char *cursorbuffer;
    short cursorx, cursory;
    struct menudata *menudat;
    long pad[10];
} WINDOWDATA;

#define BITDEF(bit)	(1<<bit)

/* Window flags */
#define WINFLAG_NEWACTIVE	BITDEF(0)
#define WINFLAG_CURSORDISP	BITDEF(1)
#define WINFLAG_CURSORON	BITDEF(2)
#define WINFLAG_CURSORSET	BITDEF(3)
#define WINFLAG_MENUON		BITDEF(4)
#define WINFLAG_TAGWINDOW	BITDEF(5)

/* Menu flags */
#define MENUFLAG_UPDATED	BITDEF(0)

/* color names */
enum color {
    BLACK = 0,
    WHITE,
    GRAY1,
    GRAY2,
    GRAY3,
    GRAY4,
    GRAY5,
    GRAY6,
    COLOR8,
    COLOR9,
    RED = 10,
    GREEN,
    YELLOW,
    BLUE,
    COLOR14,
    COLOR15
};

void draw(CORD3D * co);
void move(CORD3D * co);
void areamove(CORD3D * co);
void areadraw(CORD3D * co);
void areaend(void);
void line(CORD3D * cordbas, char start, char end);
void surface(CORD3D * cordbas, char numcord, char *cords);
void initgfx(struct MsgPort * IDCMPPort);
void closegfx(void);
void clearscreen(void);
void getcent(void);
int setcolor(int color);
int setocolor(int color);
int selectwindow(struct windowdata * windat);
void getwindowdata(struct windowdata * windat);
void makewindowdata(struct windowdata * windat, struct Window * win);
struct Window *openwindow(struct windowdata * windat);
void closewindow(struct windowdata * windat);
void initareafill(void);
void pset(CORD3D * cord);
void closeareafill(void);
void setgadget(struct windowdata * windat, int gadgid, int state);
void windowfront(struct windowdata * windat);
void windowback(struct windowdata * windat);
void draw_ball(CORD3D * cord, short radie);
void circle(CORD3D * co, int radie);
void init_cursor(void);
void setcursor(CORD3D * pos);
void restore_cursor(void);
void draw_cursor(short x, short y);
void cursoroff(void);
void cursoron(void);
void setcursorbm(void);
int setcursorcolor(int color);
void menu_on(struct windowdata * windat);
void menu_off(struct windowdata * windat);
void setmenu(struct windowdata * windat, struct menudata * menudat);
void createmenu(struct menudata * menudat);
void freemenu(struct menudate * menudat);
void movedelta(int x, int y);
void drawdelta(int x, int y);
void psetdelta(int x, int y);
void set_menustate(struct menudata * menudat, int menu, int item, int sub, int state);
void setmenustate(struct menudata * menudat, int menu, int item, int sub, int state);
void setfillmode(FILLMODE mode);
int getmenustate(struct menudata * menudat, int menu, int item, int sub);
