/*
 * source/vector/vector.c
 * SpacePigs VectorMania WorkFile for vektorroutines...
 */

#include <stdlib.h>

#include "other/debug.h"
#include "graphics/graphics.h"
#include "vector/vector.h"

int check_overlap(ELEMENT * elem1, ELEMENT * elem2)
{
    if (ELEMMIN(elem1, z) >= ELEMMAX(elem2, z))
	return 0;
    if (ELEMMAX(elem1, x) <= ELEMMIN(elem2, x))
	return 0;
    if (ELEMMIN(elem1, x) >= ELEMMAX(elem2, x))
	return 0;
    if (ELEMMAX(elem1, y) <= ELEMMIN(elem2, y))
	return 0;
    if (ELEMMIN(elem1, y) >= ELEMMAX(elem2, y))
	return 0;

    return 1;
}

int overlap_element(struct element * elem1, struct element * elem2)
{
    int overlap = 0;
    char type1, type2;

    if (!check_overlap(elem1, elem2))
	return 0;

    type1 = elem1->type;
    type2 = elem2->type;

    switch (type1) {
    case DT_LINE:
	switch (type2) {
	case DT_LINE:
	    overlap = overlap_line_line(
					   (struct element_line *) elem1,
					   (struct element_line *) elem2);
	    break;
	default:
	    saydebug("Cant overlap line against type %d\n"
		     ,elem2->type);
	}
	break;
    case DT_SURF:
    case DT_SURFFRONT:
	switch (type2) {
	case DT_SURF:
	case DT_SURFFRONT:
	    overlap = overlap_surf_surf(
					   (struct element_surf *) elem1,
					   (struct element_surf *) elem2);
	    break;
	default:
	    saydebug("Cant overlap surf against type %d\n"
		     ,elem2->type);
	    break;
	}
	break;
    default:
	saydebug("Cant overlap type %d\n", elem1->type);
    }
    return overlap;
}

int checkcordinelem(struct Cord3d * cord, ELEMENT * elem)
{
    struct Cord3d *cbase;
    int numcords;
    char *cords;
    int cnum;

    cbase = elem->cbase;
    cords = elem->cords;
    numcords = elem->numcords;

    for (cnum = 0; cnum < numcords; cnum++) {
	if (cmpcords(cord, &cbase[cords[cnum]]) == 0)
	    return 1;
    }
    return 0;
}
